      PROGRAM INPUT
C
C**************************************************************************
C
C     PROGRAM FOR DATA GENERATION
C
C**************************************************************************
C
C     1) INPUT FILE    : INFILE
C     2) OUTPUT FILES  : DATA0, DATA1, DATA2
C     3) PROGRAMMED BY : RICHARD LIEW (VERSION 1.0)
C                      : KIM, SEUNG-EOCK (VERSION 2.0)
C                        STRUCTURES AREA, SCHOOL OF CIVIL ENGINEERING 
C                        PURDUE UNIVERSITY 
C     4) LAST CHANGED  : JUNE 1996
C
C**************************************************************************
C                                                                                CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    M A I N    P R O G R A M    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        PARAMETER (MAXDOF=300,MCTYPE=30,MFTYPE=30,MTTYPE=30,
     &             MAXCNT=150,MAXFRM=100,MAXTRS=150)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION CTYPE(MCTYPE,3),FTYPE(MFTYPE,5),TTYPE(MTTYPE,4),
     &            IFMCNT(MAXCNT),
     &            IEND(MAXCNT),JDCNT(MAXCNT),FXO(MAXFRM),FYO(MAXFRM),
     &            JDFRM(MAXFRM),NFRMCO(MAXFRM,6),TXO(MAXTRS),
     &            TYO(MAXTRS),JDTRS(MAXTRS),NTRSCO(MAXTRS,4),
     &            NLDOF(MAXDOF),FMAG(MAXDOF,3),
     &            RGSI1(MAXDOF),RGSF(MAXDOF),RGSI2(MAXDOF)
        DATA IZERO /0/
        OPEN (UNIT=1,FILE='INFILE',STATUS='OLD',FORM='FORMATTED')
        OPEN (UNIT=2,FILE='DATA1',FORM='FORMATTED')
        OPEN (UNIT=3,FILE='DATA2',FORM='FORMATTED')
        OPEN (UNIT=11,FILE='DATA0',FORM='FORMATTED')
C
C    INITIALIZATION
        CALL INITM  (CTYPE,MCTYPE,3)
        CALL INITM  (FTYPE,MFTYPE,5)
        CALL INITM  (TTYPE,MTTYPE,4)
        CALL INITIV (IFMCNT,MAXCNT)
        CALL INITIV (IEND,MAXCNT)
        CALL INITIV (JDCNT,MAXCNT)
        CALL INITRV (FXO,MAXFRM)
        CALL INITRV (FYO,MAXFRM)
        CALL INITIV (JDFRM,MAXFRM)
        CALL INITM2 (NFRMCO,MAXFRM,6)
        CALL INITRV (TXO,MAXTRS)
        CALL INITRV (TYO,MAXTRS)
        CALL INITIV (IDTRS,MAXTRS)
        CALL INITM2 (NTRSCO,MAXTRS,4)
        CALL INITIV (NLDOF,MAXDOF)
        CALL INITM  (FMAG,MAXDOF,3)
        CALL INITRV (RGSI1,MAXDOF)
        CALL INITRV (RGSF,MAXDOF)
        CALL INITRV (RGSI2,MAXDOF)
        IGEOIM=0
        ILRFD=0
        ICOL=0
C
C
C    READ IN NUMBER OF DEGREES OF FREEDOM OF THE STRUCTURE, NUMBER OF
C    LOAD INCREMENTS, NUMBER OF LOAD SEQUENCES, FLAG FOR PRINTING
C    MEMBER-END FORCES, NUMBER OF ELEMENT TYPES OF EACH TYPE OF ELEMENT
C    AMD NUMBER OF ELEMENTS IN EACH TYPE OF ELEMENT


        READ (1,8) ISOLVE,IGEOIM,ILRFD
        IF (ISOLVE.EQ.1) READ (1,9) IET,IPHI
        READ (1,7) NDOFS,NINCRE,NSEQN,IPRTFC
        READ (1,2) NCTYPE,NFTYPE,NTTYPE
        READ (1,2) NUMCNT,NUMFRM,NUMTRS
C
C
C    READ INFORMATION OF EACH TYPE OF ELEMENT
CC    CONNECTION ELEMENT
        IF (NCTYPE.NE.0) THEN
        DO 10 I=1,NCTYPE
        READ (1,4) ICTYPE,(CTYPE(ICTYPE,J),J=1,3)
10      CONTINUE
        ENDIF
C
CC    FRAME ELEMENT
        IF (NFTYPE.NE.0) THEN
        DO 20 I=1,NFTYPE
        READ (1,6) IFTYPE,(FTYPE(IFTYPE,J),J=1,5),ICOL
        IF (ABS(FTYPE(IFTYPE,4)).LT.1.0D-05.AND.
     &      ABS(FTYPE(IFTYPE,5)).LT.1.0D-05) THEN
        FTYPE(IFTYPE,4)=FTYPE(IFTYPE-1,4)
        FTYPE(IFTYPE,5)=FTYPE(IFTYPE-1,5)
        ENDIF
        IF (IGEOIM.EQ.3.AND.ICOL.EQ.1) THEN
        FTYPE(IFTYPE,4)=FTYPE(IFTYPE,4)*0.85D+00
        ENDIF
20      CONTINUE
        ENDIF
C
CC    TRUSS ELEMENT
        IF (NTTYPE.NE.0) THEN
        DO 30 I=1,NTTYPE
        READ (1,4) ITTYPE,(TTYPE(ITTYPE,J),J=1,4),ICOL
        IF (ABS(TTYPE(ITTYPE,3)).LT.1.0D-05.AND.
     &      ABS(TTYPE(ITTYPE,4)).LT.1.0D-05) THEN
        TTYPE(ITTYPE,3)=TTYPE(ITTYPE-1,3)
        TTYPE(ITTYPE,4)=TTYPE(ITTYPE-1,4)
        ENDIF
        IF (IGEOIM.EQ.3.AND.ICOL.EQ.1) THEN
        TTYPE(ITTYPE,3)=TTYPE(ITTYPE,3)*0.85D+00
        ENDIF
30      CONTINUE
        ENDIF
C
C
C    READ INFORMATION OF EACH ELEMENT
CC    CONNECTION ELEMENT
        IF (NUMCNT.NE.0) THEN
        DO 60 I=1,NUMCNT
        READ (1,1) LCNT,IFMCNT(LCNT),IEND(LCNT),JDCNT(LCNT)
60      CONTINUE
        ENDIF
C
CC    FRAME ELEMENT
        IF (NUMFRM.NE.0) THEN
        DO 70 I=1,NUMFRM
        READ (1,12) LFRM,FXO(LFRM),FYO(LFRM),JDFRM(LFRM),
     &              (NFRMCO(LFRM,J),J=1,6)
        IF (ABS(FXO(LFRM)).LT.1.0D-05.AND.ABS(FYO(LFRM)).LT.1.0D-05)
     &  THEN
        FXO(LFRM)=FXO(LFRM-1)
        FYO(LFRM)=FYO(LFRM-1)
        ENDIF
        IF (JDFRM(LFRM).EQ.0) JDFRM(LFRM)=JDFRM(LFRM-1)
70      CONTINUE
        ENDIF
C
CC    TRUSS ELEMENT
        IF (NUMTRS.NE.0) THEN
        DO 80 I=1,NUMTRS
        READ (1,13) LTRS,TXO(LTRS),TYO(LTRS),JDTRS(LTRS),
     &              (NTRSCO(LTRS,J),J=1,4)
        IF (ABS(TXO(LTRS)).LT.1.0D-05.AND.ABS(TYO(LTRS)).LT.1.0D-05)
     &  THEN
        TXO(LTRS)=TXO(LTRS-1)
        TYO(LTRS)=TYO(LTRS-1)
        ENDIF
        IF (JDTRS(LTRS).EQ.0) JDTRS(LTRS)=JDTRS(LTRS-1)
80      CONTINUE
        ENDIF
C
C
C    READ IN LOAD VECTOR
        DO 110 I=1,NDOFS
        READ (1,16,END=1000) NLDOF(I),(FMAG(I,J),J=1,3)
        IF (ABS(FMAG(I,1)).LT.1.0D-05.AND.ABS(FMAG(I,2)).LT.1.0D-05
     &      .AND.ABS(FMAG(I,3)).LT.1.0D-05) THEN
        FMAG(I,1)=FMAG(I-1,1)
        FMAG(I,2)=FMAG(I-1,2)
        FMAG(I,3)=FMAG(I-1,3)
        ENDIF
110     CONTINUE
C
1000    CONTINUE
        ILOAD=I-1
C
C ********** CREATE DATAS0 ********** C
C
        WRITE (11,101) ISOLVE,IGEOIM,ILRFD
        IF (ISOLVE.EQ.1) WRITE (11,102) IET,IPHI
C
C ********** CREATE DATAS1 ********** C
C
        WRITE (2,201) NDOFS,NINCRE,NSEQN,IPRTFC
        WRITE (2,202) NCTYPE,NFTYPE,NTTYPE
        WRITE (2,202) NUMCNT,NUMFRM,NUMTRS
        IF (NCTYPE.NE.0) THEN
        DO 120 I=1,NCTYPE
        WRITE (2,203) I,(CTYPE(I,J),J=1,3)
120     CONTINUE
        ENDIF
C
        DO 130 I=1,ILOAD
        RGSI1(NLDOF(I))=FMAG(I,1)
        IF (NSEQN.EQ.2) THEN
        RGSF(NLDOF(I))=FMAG(I,2)
        RGSI2(NLDOF(I))=FMAG(I,3)
        ENDIF
130     CONTINUE
C
        WRITE (2,205) (RGSI1(I),I=1,NDOFS)
        IF (NSEQN.EQ.2) THEN
        WRITE (2,205) (RGSF(I),I=1,NDOFS)
        WRITE (2,205) (RGSI2(I),I=1,NDOFS)
        ENDIF
C
C ********** CREATE DATAS2 ********** C
C
CC    FRAME ELEMENT
        IF (NUMFRM.NE.0) THEN
          DO 140 I=1,NUMFRM
            WRITE (3,301) I,FXO(I),FYO(I),(FTYPE(JDFRM(I),J),J=1,5)
            IFLAGC=0
            DO 150 II=1,NUMCNT
            IF (I.EQ.IFMCNT(II)) THEN
              IFLAGC=1
              III=II
            ENDIF
150         CONTINUE
            IF (IFLAGC.EQ.0) THEN
              WRITE (3,302) IZERO,IZERO,IZERO
            ELSE IF (IFLAGC.EQ.1) THEN
              WRITE (3,302) 1,IEND(III),JDCNT(III)
            ENDIF
            WRITE (3,305) (NFRMCO(I,J),J=1,6)
140       CONTINUE
        ENDIF
C
CC    TRUSS ELEMENT
        IF (NUMTRS.NE.0) THEN
        DO 170 I=1,NUMTRS
        WRITE (3,308) I,TXO(I),TYO(I),(TTYPE(JDTRS(I),J),J=1,4)
        WRITE (3,309) (NTRSCO(I,J),J=1,4)
170     CONTINUE
        ENDIF
C
        ENDFILE (2)
        CLOSE (UNIT=2,STATUS='KEEP')
        ENDFILE (3)
        CLOSE (UNIT=3,STATUS='KEEP')
C
C
C    FORMAT STATEMENTS
1       FORMAT (4I5)
2       FORMAT (3I5)
4       FORMAT (I5,4D10.0,I5)
5       FORMAT (6D10.0)
6       FORMAT (I5,5D10.0,I5)
7       FORMAT (4I5)
8       FORMAT (/ 3I5)
9       FORMAT (2I5)
12      FORMAT (I5,2D10.0,10I5)
13      FORMAT (I5,2D10.0,5I5)
16      FORMAT (I5,3D10.0)
101     FORMAT (3I5)
102     FORMAT (2I5)
201     FORMAT (4I5)
202     FORMAT (3I5)
203     FORMAT (I5,3D12.5)
204     FORMAT (6D12.5)
205     FORMAT (8D12.5)
301     FORMAT (I5,7D12.5)
302     FORMAT (3I5)
305     FORMAT (6I5)
308     FORMAT (I5,7D12.5)
309     FORMAT (4I5)
C
        STOP
        END
C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    S U B R O U T I N E S    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        SUBROUTINE INITM (A,MA,NA)
C    THIS SUBROUTINE INITIALIZES A MATRIX OF SIZE MAXNA
        DOUBLE PRECISION A
        DIMENSION A(MA,NA)
        DO 10 I=1,MA
        DO 10 J=1,NA
10      A(I,J)=0.D00
        RETURN
        END    
        
        SUBROUTINE INITM2 (MNA,MA,NA)
C    THIS SUBROUTINE INITIALIZES A MATRIX OF SIZE MAXNA
        DIMENSION MNA(MA,NA)
        DO 10 I=1,MA
        DO 10 J=1,NA
10      MNA(I,J)=0.D00
        RETURN
        END
C
C
C
        SUBROUTINE INITRV (RV,MV)
C    THIS SUBROUTINE INITIALIZES A REAL VECTOR OF SIZE MVX1
        DOUBLE PRECISION RV
        DIMENSION RV(MV)
        DO 10 I=1,MV
10      RV(I)=0.D00
        RETURN
        END
C
C
C
        SUBROUTINE INITIV (IV,MV)
C    THIS SUBROUTINE INITIALIZES AN INTEGER VECTOR OF SIZE MVX1
        DIMENSION IV(MV)
        DO 10 I=1,MV
10      IV(I)=0
        RETURN
        END

